Attribute VB_Name = "FileHandlerForForms"
Option Explicit

'OUTPUT: returns selected file name or "" if cancelled;
'DEPENDENCIES: no global variables used;
'              depends on EXCEPTION procedures;
Public Function SelectFileForOpening$( _
       FileNameToStart$, _
       FilterToStart$, _
       Common_Dialog As CommonDialog)

SelectFileForOpening = ""
With Common_Dialog
        .Filter = FilterToStart
        .FileName = FileNameToStart
        .CancelError = True
        On Error Resume Next
        .ShowOpen
        If Err.Number > 0 Then
           If Err.Number = cdlCancel Then
              Err.Clear
              Exit Function
           Else
              e_raise "exception when selecting a file to open ... "
           End If
        End If
        On Error GoTo he
        SelectFileForOpening = .FileName
End With
Exit Function

he: xMe = Err.Description
    xNo = Err.Number
    Resume xNext
xNext:
    On Error GoTo 0
    eUp "when selecting file for opening"
        
End Function

Public Function SelectFileForSaving$(InitialFile$, InitialFilter$, Common_Dialog As CommonDialog)
SelectFileForSaving = ""

With Common_Dialog
.FileName = InitialFile
.CancelError = True
.Filter = InitialFilter
  
On Error Resume Next
.ShowSave
If Err.Number > 0 Then
    If Err.Number = cdlCancel Then
        Err.Clear
        Exit Function
    Else
        e_raise "exception when selecting a file" & InitialFile & " ... "
    End If
End If
On Error GoTo DDummy
SelectFileForSaving = .FileName
End With
DDummy:

End Function

'EXCE not free
'DESC if file name <> "" and
'     if text      <> "",
'     opends and appends to a file.
'
'
'hadles errors using standard VB error handling mechanism
'do not do anything if file name or text_to_append are empty
'
Sub OpenAndAppendToFile(file_name$, text_to_append$)
    
    Dim handler%
    
    If file_name = "" Then Exit Sub
    If text_to_append = "" Then Exit Sub
    
    On Error GoTo open_error
    handler = FreeFile
    Open file_name For Append Shared As #handler
    On Error GoTo writing_error
    Print #handler, text_to_append;
    Close #handler
    Exit Sub
    
open_error:
    xMe = Err.Description
    xNo = Err.Number
    Resume xNext
xNext:
    On Error GoTo 0
    eUp "in OpenAndAppendToFile" & ve & _
        "when opening file " & ve & _
        file_name
    
writing_error:
    xMe = Err.Description
    xNo = Err.Number
    Resume xNext2
xNext2:
    On Error GoTo 0
    Close #handler
    eUp "in OpenAndAppendToFile" & ve & _
        "when writing to file " & ve & _
        file_name
    
End Sub

'OUTPUT: combined ParentPath$ and FileNameEnd to make a full path;
'
'
Public Function path_ReSplit$(ParentPath$, FileNameEnd$)
    Dim CutSlash$
    Select Case Right(ParentPath, 1)
      Case "\": path_ReSplit = ParentPath & FileNameEnd
      Case "":   path_ReSplit = FileNameEnd
      Case Else:
           If FileNameEnd <> "" Then path_ReSplit = ParentPath & "\" & FileNameEnd
    End Select
End Function

Public Function fileMayBeRoot$(FullFileName$)

If FullFileName <> "" And Len(FullFileName) < 3 Then
   'this may mean that converting into a root ...
   fileMayBeRoot "File/folder " & ve & FullFileName _
         & ve & "may be a root ... " & _
         "and will not be proceessed ... "
End If

End Function


