Attribute VB_Name = "UStrings"
'====================================
'  String procedures to serve
'  file name conversions.
'  Can be useful in genral case also.
'  No dependencies.
'  Tested in VB4. November 11, 2002.
'====================================
Option Explicit
 

'EXCEP  free
'DESCR  Returns condensed file name:
'       like:  c:\fodder\..\x.htm -->
'              c:\x.htm
'INPUT  absolute path only
'OUTPU  If exception, then "" returned.
'       After compression,
'         no "\..\" are left in path name,
'         no "\.." is left at the end.
'
'
Public Function fileCompressName$(s$)
Dim ws$, I&, j&, res$

fileCompressName = ""
res = s
I = InStr(res, "\..\")

Do While I > 0
   'find previous folder divider:
   'I-1 is a start position here:
   j = getNthOccurencePosition&( _
       "\", res, I - 1, 1, 1)
   If 0 = j Then
      'exception: wrong name
      Exit Function
   End If
   res = Left(res, j) & Mid(res, I + 4)
   I = InStr(res, "\..\")
Loop

If "\.." = Right(res, 3) Then
   I = Len(res) - 3
   If I < 1 Then Exit Function
   j = getNthOccurencePosition&( _
       "\", res, I, 1, 1)
   If 2 > j Then
      Exit Function
      'exception: wrong name
   End If
   res = Left(res, j - 1)
End If
fileCompressName = res

End Function


'EXCEP free
'DESC  Creates path of unit f2 relative to unit f1.
'      Example: f1=c:\a\b\x.txt f2=c:\a\y.txt
'               result = ..\y.txt
'NOTE  if f1 and f2 are not absolute paths
'      of the same drive
'      (if they both not start with the same x:\),
'      then f2 is returned.
'
Public Function fileMakeRelative$(f1$, f2$)
Dim scomm$, n&, deepness&, s

'===========================================================
' validate input
'-----------------------------------------------------------
If ":\" <> Mid(f1, 2, 2) Or _
   UCase(Mid(f1, 1, 3)) <> UCase(Mid(f2, 1, 3)) Then
   fileMakeRelative = f2
   Exit Function
End If
'===========================================================

scomm = getCommonBeginning(f1, f2, False, n)
'common part is good, but it can have extra
'characters after slash: ...\name...:
'                           ^slash
'return to this slash making backward search:
'       n - where to start
'       1 - seach in backward direction
'       1 - how many to search:
n = getNthOccurencePosition("\", f1, n, 1, 1)
'how deep is f1 tail:
'deepness = how many occurances of "\":
RePlaceFast Mid(f1, n + 1), "\", "\", deepness, False
fileMakeRelative = gString(deepness, "..\") & Mid(f2, n + 1)
   
End Function

'EXCEP  Free
'DESCR  Assuming that f1 is main unit,
'       adds relative path to parent of f1
'       and condenses the result.
'       if f2 is "" then "" is returned.
'       If f2 is full path, then f2 is returned.
'       If no "\" in f1 (something wrong in f1),
'                       then App.Path\f2 is returned.
'
'EXAMP  f1="c:\moo\goo.txt" f2="..\too.txt"
'       Returns:  "c:\too.txt"
'
Public Function fileMakeAbsolute$(f1$, f2$)
Dim ParentFolderPos$, s$

If "" = f2 Then Exit Function

s = ""

If ":" = Mid(f2, 2, 1) Then
    s = f2
Else
   ParentFolderPos = getNthOccurencePosition&( _
       "\", f1, 0, 1, 1)
   If 1 > ParentFolderPos Then _
      s = App.Path & "\" & f2
End If

If "" = s Then s = Left(f1, ParentFolderPos) & f2
fileMakeAbsolute = fileCompressName(s)

End Function


'EXCEP  free
'DESC   k_ey_char - which to look for
'       s         - where to look for
'       s_tart    - where to start
'                   if <1 then from 1 for normal
'                                     direction
'                                   0 for reverse
'       d_ir      - direction
'                   0 - normal, 1 or other -reverse
'       n         - how many to search;
'                 - if n<1, then
'                   search as many as are;
'OUTPUT 0         - if no succes
'       position  - if success
'
Public Function getNthOccurencePosition&( _
       k_ey_char$, s$, s_tart&, d_ir&, n&)
Dim I&, iStep&, iStart&, iEnd&, iLen&, iOcc&

iLen = Len(s)
If 0 = iLen Or Len(k_ey_char) = 0 Then _
   Exit Function

Select Case d_ir
   Case 0:  'normal direction
        iStart = s_tart
        If s_tart < 1 Then iStart = 1
        iStep = 1
        iEnd = iLen
   Case Else:  'reverse direction
        iStart = s_tart
        If s_tart < 1 Then iStart = Len(s)
        iStep = -1
        iEnd = 1
End Select

iOcc = 0
For I = iStart To iEnd Step iStep
   If Mid(s, I, 1) = k_ey_char$ Then
      iOcc = iOcc + 1
      If iOcc = n Then
         getNthOccurencePosition = I
         Exit Function
      End If
   End If
Next
   
    
End Function

'DESC   generate n-times gPattern string
'EXCEP  free
'YELDS  no
'
Public Function gString$(n&, gPattern$)
Dim w$, I&

If 1 > n Then
   w = ""
Else
   w = String(n, "x")
End If
gString = RePlaceFast(w, "x", gPattern, I, False)

End Function


'DESCR               replaces
'                    Ke_y with Va_lue in s;
'EXCEP               free
'INPUT RESTRICTINS   none
'YELDS               depends on Yeld input par;
'OUTPUT              returns replaced string;
'                    Occurances - number of them;
'NOTE                slow, but good for VB4;
'
Public Function RePlaceFast$( _
       s$, Ke_y$, Va_lue$, Occurances&, _
       Yeld As Boolean)
Dim I&, L&, Sta_rt&, WRePlaceFast$, Key_Length$

Occurances = 0
WRePlaceFast = s
L = Len(s)

If L = 0 Then GoTo ExitFunction
Key_Length = Len(Ke_y)
If Key_Length = 0 Then Exit Function

Sta_rt = 1
WRePlaceFast = ""
I = InStr(Sta_rt, s, Ke_y)
Do While I <> 0
   If Yeld Then DoEvents
   'add piece before escape char:
   WRePlaceFast = WRePlaceFast & _
         Mid(s, Sta_rt, I - Sta_rt)
   Occurances = Occurances + 1
   WRePlaceFast = WRePlaceFast & Va_lue
   Sta_rt = I + Key_Length
   I = InStr(Sta_rt, s, Ke_y)
Loop
If Sta_rt <= L Then WRePlaceFast = _
        WRePlaceFast & Mid(s, Sta_rt)
ExitFunction: RePlaceFast = WRePlaceFast
Exit Function

End Function

'YIELD  no
'EXCEP  free
'DESCR  Deescaping:
'       fe:
'         \\ --> \
'         \l --> CRLF
'         ....
'NOTE  not matched char after "\" ignored
'
Public Function ReDe$(SourceStr$, Escaper$)
Dim SourceLen&
Dim pos&, EscaperPosition&
Dim res$

res = ""
SourceLen = Len(SourceStr)
pos = 1
       
Do While pos <= SourceLen
    EscaperPosition = InStr(pos, SourceStr, Escaper)
    If 0 = EscaperPosition Then
      'remainder of source text is clean: add it:
      res = res & Mid(SourceStr, pos)
      Exit Do
    End If
    res = res & Mid(SourceStr, pos, EscaperPosition - pos)
    Select Case Mid(SourceStr, EscaperPosition + 1, 1)
        Case Escaper
             res = res & Escaper
        Case "z"
             res = res & "z"
        Case "l"
             res = res & vbCrLf
        Case "r"
             res = res & vbCr
        Case "n"
             res = res & vbLf
        Case Else
    End Select
    pos = EscaperPosition + 2
Loop

ReDe = res

End Function


'EXCEP  free
'DESCR  Returns common beginning of two strings.
'       if SenseCase then comparision is case
'                         sensetive
'OUTPUT Returns common part.
'       n - last coincided character.
'NOTE   Very slow, but good for small strings.
'
Public Function getCommonBeginning$( _
       s1$, s2$, SenseCase, n&)
Dim iLen&, I&

iLen = Len(s1)
If Len(s2) < iLen Then iLen = Len(s2)
n = 0
If 0 = iLen Then Exit Function

For I = 1 To iLen
    If SenseCase Then
       If Mid(s1, I, 1) <> Mid(s2, I, 1) Then _
       GoTo Found
    Else
       If UCase(Mid(s1, I, 1)) <> _
          UCase(Mid(s2, I, 1)) Then _
       GoTo Found
    End If
Next
I = iLen + 1  'not sure if redundant;

Found:
getCommonBeginning = Left(s1, I - 1)
n = I - 1

End Function


