VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CVariables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private moAc As sscomp
Private moPc As CProcedure
Private moPr As CPrint
Private moDv As CDiskVariables
Private moDlg As CDialog         'Only for DlgPs?
Private moTz As CTokenizer       'Initially only for position in Source Text.
Private moFt As CFolderTree

Private var_List$
Private var_AssignedDuringText&()
Private Const var_Exists$ = vbLf
Private Const var_Erased$ = vbCr
Private var_Values$()   'do2: Should be public for speed.

Public var_DEFAULT_NAMES_POSITION$
Public var_BeforeRunTimeCreatedVarPosition&


Public p_vars_after_shema_prj&                  'Auxiliary

'For exception
Private espot$

Public Sub SetMoActo(ac As sscomp)
Set moAc = ac
End Sub

Public Sub SetMoDialog(dlg As CDialog)
Set moDlg = dlg
End Sub

'NOT USED YET
Public Sub ClearFlagsOfPreviousTextAssignments()

Dim I&, StockCount&, startPosition&
StockCount = UBound(var_Values)
If p_vars_after_shema_prj < var_DEFAULT_NAMES_POSITION Then Exit Sub

For I = p_vars_after_shema_prj To StockCount
    var_AssignedDuringText(I) = 0
Next

End Sub

Public Sub SetMoDiskVariables(dv As CDiskVariables)
Set moDv = dv
End Sub

Public Sub SetMoFolderTree(ft As CFolderTree)
Set moFt = ft
End Sub

Public Sub SetMoProcedure(pc As CProcedure)
Set moPc = pc
End Sub


Public Sub SetMoPrint(pr As CPrint)
Set moPr = pr
End Sub

Public Sub SetMoTokenizer(tz As CTokenizer)
Set moTz = tz
End Sub

Public Function UboundVarValues&()
UboundVarValues = UBound(var_Values)
End Function

'DESC   Allows recursive v-name contruction.
'       Truncates resulted name if longer than 32 chars.
'
'NOTE: recognizes:
'      Variable variables: prefix$Contains_name_of_variable:
'
Public Function var_BuildVarName$(VNameP$)
Dim wi&, WSS$
Dim ws$  'Variable name in progress.

ws = VNameP

CheckDollarPresence:

If "" = ws Then
   var_BuildVarName = "token"
   Exit Function
End If

'=====================================
'protectors for "32" and for case
'if wrong name retrieved recursively:
If Len(ws) > 32 Then ws = Left(ws, 32)
If InStr(ws, var_Exists) > 0 Then
   ws = "token"
ElseIf InStr(ws, var_Erased) > 0 Then
   ws = "token"
ElseIf InStr(ws, " ") > 0 Then
   ws = "token"
End If
'=====================================
  
wi = InStr(ws, alph__Variable)

If wi <> 0 Then
   DoEvents
   If wi > 1 Then WSS = Left(ws, wi - 1) Else WSS = ""
   ws = WSS & var_Get(Mid(ws, wi + 1))
   GoTo CheckDollarPresence
End If

var_BuildVarName = ws

End Function

Public Function var_GetIndexVerify&(VNameP$)

Dim VSearch$, VPosition&, VName$

'kk.do2: slow:
VName = var_BuildVarName(VNameP)
If VName = "@" Then Exit Function

'Duplicated code: from: var_GetIndexNotCreate
VSearch = Space(33)
LSet VSearch = var_Exists & VName
var_GetIndexVerify = CLng(InStr(var_List, VSearch) / 33)


End Function

'DESC VName must be well defined and checked.
'     The only proc which creates new var.
'     Returned index is always well defined and > 0.
'
Private Function var_GetIndexMayCreate&(VName$)
Dim VSearch$, ws$, VPosition&

VSearch = Space(33)
LSet VSearch = var_Exists & VName
VPosition = CLng(InStr(var_List, VSearch) / 33)

If VPosition > 0 Then
   var_GetIndexMayCreate = VPosition
   Exit Function
End If
   
'var is not found:
ws = Space(33) 'String(33, Chr(10)) ' Space(33)
LSet ws = var_Exists & VName
   
'for the future:
'seach for gabls in variable list;
'gab flag is var_Erased;
'VPosition = InStr(var_List, var_Erased)
'If VPosition = 0 Then
      
''Feature since 1.22.217 no erased variables.
''
''If 0 = VPosition Then
      'no empty space: current version:
      'add space to both array and the list;
      VPosition = UBound(var_Values) + 1
      var_List = var_List & ws
      ReDim Preserve var_Values(VPosition)
      If UBound(var_AssignedDuringText) < VPosition Then
         ReDim Preserve var_AssignedDuringText(VPosition)
      End If
      var_Values(VPosition) = ""
      var_AssignedDuringText(VPosition) = 0

''Else
''      'an empty space is found:
''      'fill this gab:
''      Mid(var_List, VPosition) = ws
''      var_Values(VPosition / 33) = ""
''      var_AssignedDuringText(VPosition) = 0
''End If

var_GetIndexMayCreate = VPosition

End Function

'EXCE free
'
'DESC VName must be well-defined.
'     If var does not exist, zero is returned.
Private Function var_GetIndexNotCreate&(VName$)
  Dim VSearch$, VPosition&
  VSearch = Space(33)
  LSet VSearch = var_Exists & VName
  var_GetIndexNotCreate = CLng(InStr(var_List, VSearch) / 33)
End Function


'///////////////////////////////////////////////////////////////////////////
'
'SYNTAX:  name size is from 1 ... to 32
'         name cannot have cr and lf
'
'         name-list format:
'           _ _ _ _ ... _ _   <--- 33 spaces; this first slot
'                                     line ends at position 32;
'           lf name spaces    <--- size of "name spaces" = 32
'           lf name spaces    <--- for occupied name-slot
'           ...
'           lf cr             <--- for empty name-slot
'           lf lf             <--- occupied, not used name-slot
'
'           first X entries are reserved;
'
'NOTE: ONLY FOUR PLACES MUST BE MODIFIED WHEN ADDING/DELETING
'      NEW INTRINSINC==RESERVED VARIABLES:
'
'         1) var_Init:  add new LSet and
'                       increase var_DEFAULT_NAMES_POSITION
'         2) var_Get
'         3) var_SetByKnownIndex
'
'         The rest is only if variable is non-standard variable.
'         Reserved variable not necessarily needs extras.
'
'      NORMALLY, FOR READ-ONLY VARIABLES:
'         only var_Init and var_Get must be updated.
'
'//////////////////////////////////////////////////////////////////////
'
Public Sub var_Init()
Dim WSpace$

'------------------------------------------
'set first slot line which is simply empty:
WSpace = Space(33)
var_List$ = Space(33)
'------------------------------------------

var_DEFAULT_NAMES_POSITION = 40
'reserve dummy N cells for
'hard-coded variables word, ....

ReDim var_Values(var_DEFAULT_NAMES_POSITION)    'this array STORES values for InternalVariables;
ReDim var_AssignedDuringText(var_DEFAULT_NAMES_POSITION)


'==========================================
' fill reserved variables names:
'------------------------------------------
'==========================================
' fill reserved variables names:
'------------------------------------------
'1
LSet WSpace = var_Exists & varn_TOKEN
var_List = var_List & WSpace
'2
LSet WSpace = var_Exists & "type"
var_List = var_List & WSpace
'3
LSet WSpace = var_Exists & "indent"
var_List = var_List & WSpace

'4
LSet WSpace = var_Exists & "p_version"
var_List = var_List & WSpace

'reserved space:
'5
LSet WSpace = var_Exists & var_Exists
var_List = var_List & WSpace
'6
LSet WSpace = var_Exists & "in"
var_List = var_List & WSpace
'7
LSet WSpace = var_Exists & "out"
var_List = var_List & WSpace
'8
LSet WSpace = var_Exists & "pos"
var_List = var_List & WSpace
'9
LSet WSpace = var_Exists & "p_basic"
var_List = var_List & WSpace
'10
LSet WSpace = var_Exists & "p_extension"
var_List = var_List & WSpace
'11
LSet WSpace = var_Exists & "p_rbasic"
var_List = var_List & WSpace
'12
LSet WSpace = var_Exists & "p_rextension"
var_List = var_List & WSpace
'13
LSet WSpace = var_Exists & "p_local_path"
var_List = var_List & WSpace

'14
LSet WSpace = var_Exists & "#"
var_List = var_List & WSpace

'============================================
'19.2 Special construct. Has own array.
'15
LSet WSpace = var_Exists & "@"
var_List = var_List & WSpace
'============================================


'16
LSet WSpace = var_Exists & "@state"
var_List = var_List & WSpace
'17
LSet WSpace = var_Exists & "@nest"
var_List = var_List & WSpace
'18
LSet WSpace = var_Exists & "p_umbrella"
var_List = var_List & WSpace
'19
LSet WSpace = var_Exists & "p_shield"
var_List = var_List & WSpace
'20
LSet WSpace = var_Exists & "p_parent"
var_List = var_List & WSpace
'21
LSet WSpace = var_Exists & "p_rparent"
var_List = var_List & WSpace
'22:
LSet WSpace = var_Exists & "p_processed_files"
var_List = var_List & WSpace

'23
LSet WSpace = var_Exists & "p_file"
var_List = var_List & WSpace
'24:
LSet WSpace = var_Exists & "p_rfile"
var_List = var_List & WSpace

LSet WSpace = var_Exists & "p_file_for_GUI"
var_List = var_List & WSpace

LSet WSpace = var_Exists & "p_source"
var_List = var_List & WSpace

'27
LSet WSpace = var_Exists & "p_round"
var_List = var_List & WSpace

'28
LSet WSpace = var_Exists & "p_stop_browsing_project_tree"
var_List = var_List & WSpace

'29
LSet WSpace = var_Exists & "p_string"
var_List = var_List & WSpace

'30
LSet WSpace = var_Exists & "p_paragraph"
var_List = var_List & WSpace


'31
LSet WSpace = var_Exists & "p_created_var_list"
var_List = var_List & WSpace

'32
LSet WSpace = var_Exists & "p_all_var_list"
var_List = var_List & WSpace

'33
LSet WSpace = var_Exists & "p_reserved_var_list"
var_List = var_List & WSpace

'34
LSet WSpace = var_Exists & "p_run_time_var_list"
var_List = var_List & WSpace


'35
LSet WSpace = var_Exists & "p_keywords_enabled"
var_List = var_List & WSpace

'36
LSet WSpace = var_Exists & "p_id_is_case_sensetive"
var_List = var_List & WSpace

'37
LSet WSpace = var_Exists & "p_variables_when_bot"
var_List = var_List & WSpace

'38
LSet WSpace = var_Exists & "p_clear_variables_at_eot"
var_List = var_List & WSpace

'39
LSet WSpace = var_Exists & "p_recognize_vbtype_decl_chars"
var_List = var_List & WSpace

'40
LSet WSpace = var_Exists & "p_vbtype"
var_List = var_List & WSpace


'--------------------------------------------
'  ef name filling
'============================================
End Sub

'DESCRIPTION: VPosition must be already a valid var index.
'
Public Sub var_SetByKnownIndex(VPosition&, VValue$)

If VPosition <= var_DEFAULT_NAMES_POSITION Then

    Select Case VPosition
        Case 1: moTz.eo_token = VValue
        Case 2: moTz.eo_type = VValue
        'Case 3: 'read-only
        'Case 4: 'read only
        'Case 5: 'reserved
        Case 6: moTz.MSourceText = VValue: moTz.muPsn = 1       'obvious
        Case 7: moPr.MResultText = VValue                   'this is a result text;
        Case 8: moTz.muPsn = CLng(VValue)
        
        'read only:
        'Case 9:  'p_basic = VValue
                 'p_file = fAddExtension(p_basic, p_extension)
        'Case 10: 'p_extension = VValue
                 'p_file = fAddExtension(p_basic, p_extension)
        Case 11: p_rbasic = VValue
                 p_rfile = fAddExtension(p_rbasic, p_rextension)
        Case 12: p_rextension = VValue
                 p_rfile = fAddExtension(p_rbasic, p_rextension)
        
        'Case 13: 'read only: local_path
        'Case 14: 'read only: moDlg.dlgPs
        Case 15: moDlg.NestLevelVar(moDlg.dlgPs) = VValue
        'Case 16
        'Case 17
    
        'Case 18
        'Case 19
        'Case 20
        'Case 21
        'Case 22
        Case 25:  p_file_for_GUI = VValue
        Case 26:  'p_source
        Case 27:  moAc.Round = CLng(VValue)
        Case 28:  moPc.p_stop_browsing_project_tree = VValue
        'Case 29, 30, 31, 32, 33: read only
        Case 35:  Select Case Left(UCase(VValue), 1)
                  Case "T", "Y": moTz.env_p_keywords_enabled = True
                  Case Else:     moTz.env_p_keywords_enabled = False
                  End Select
        Case 36:  Select Case Left(UCase(VValue), 1)
                  Case "T", "Y": moDlg.env_p_id_is_case_sensetive = True
                  Case Else:     moDlg.env_p_id_is_case_sensetive = False
                  End Select
        Case 37:  Select Case VValue
                  Case "":     ClearAssignedVariables p_vars_after_shema_prj
                  Case Else:   ClearAssignedVariables VValue
                  End Select
                  
        Case 38:  Select Case Left(UCase(VValue), 1)
                  Case "T", "Y": moAc.env_p_clear_variables_at_eot = True
                  Case Else:     moAc.env_p_clear_variables_at_eot = False
                  End Select
    
        Case 39:  Select Case Left(UCase(VValue), 1)
                  Case "T", "Y": moTz.env_p_recognize_vbtype_decl_chars = True
                  Case Else:     moTz.env_p_recognize_vbtype_decl_chars = False
                  End Select
        
        Case 40:  moTz.env_p_vbtype = VValue
        
       
    End Select
Else
    var_Values(VPosition) = VValue
    If Len(VValue) > 0 Then
       var_AssignedDuringText(VPosition) = 1
    Else
       var_AssignedDuringText(VPosition) = 0
    End If
End If
End Sub



'DESCR Assign "" to all variables which marked as
'      var_AssignedDuringText(i) = 1
'      Do this work starting from "FromPosition".
'      Normally FromPosition = var_DEFAULT_NAMES_POSITION + 1
'
Public Sub ClearAssignedVariables(FromPosition)

Dim DelFrom&, I&, CurrentStock&

On Error Resume Next
DelFrom = CLng(FromPosition)
If 0 < Err.Number Then Exit Sub

If DelFrom < var_DEFAULT_NAMES_POSITION Then
   DelFrom = var_DEFAULT_NAMES_POSITION + 1
End If

CurrentStock = UBound(var_Values)
If CurrentStock < DelFrom Then Exit Sub

For I = DelFrom To CurrentStock
    If 1 = var_AssignedDuringText(I) Then
       var_Values(I) = ""
       var_AssignedDuringText(I) = 0
    End If
Next

End Sub


'YELD no
'
'speeding up vars operations;
'USE  used often;
'     for finding token, parsing schema,
'         processing instruction;
'NOTE SourceLen and SourceStr can be changed
'     diring execution.
'
Public Function var_SubstituteShortCuts$(SourceStrP$)

Const c_Cond As String = "Incorrect operators \? \! syntax: missed "

Dim res$, SourceLen&, pos&, pos2&
Dim WSecondChar$, WVarLimitor&, WVName$

Dim Limitor&
Dim wComma&, wFirstPar$, wSecondPar$
Dim wPreSubString$, wPar$

Dim wp1&, wp2&, wp3&, wp4&   'to hold string separators
Dim wi&

Dim ws1$, ws2$, ws3$, ws4$
Dim ws$, WSS$, wss2$

Dim WRes$

Dim SourceStr$
Dim WUnescapedString$


Dim EscaperPosition&  'let us begin to fix this dirty code;
Dim EscaperPosition1&
Dim EscaperPosition2&



res = ""
SourceLen = Len(SourceStrP)
If 0 = SourceLen Then GoTo EndFunction

SourceStr = SourceStrP
pos = 1
       
Do While pos <= SourceLen
    pos2 = InStr(pos, SourceStr, alph__EscInText)
    EscaperPosition = pos2
    EscaperPosition1 = EscaperPosition + 1
    EscaperPosition2 = EscaperPosition + 2
    If 0 = EscaperPosition Then
      'remainder of source text is clean: add it:
      res = res & Mid(SourceStr, pos)
      Exit Do
    End If
   
    'something like \$ .. or \shortcut is found;
    'first, preserv text which lies before Main Shortcut:
    res = res & Mid(SourceStr, pos, EscaperPosition - pos)
    
    
    WSecondChar = Mid(SourceStr, EscaperPosition1, 1)
    If WSecondChar = "" Then Exit Do
            'this is the end of text: nothing is
            'after the Main Escape:
            'do not preserve this last escape:
            'Res = Res & alph__EscInText
            'Exit Do
    Select Case WSecondChar       '$ or other ...
        Case alph__Variable:      'pos2+1<-->"$"; variable is here;
             WVarLimitor = InStr(EscaperPosition1, _
                           SourceStr, alph__VariableEscapeLimitor)
             If WVarLimitor = 0 Then
                'var name is limited by the end of string;
                'very good for string fragmets
                'extracted from parent string:
                WVarLimitor = SourceLen + 1
             End If
             WVName = Trim(Mid(SourceStr, pos2 + 2, WVarLimitor - pos2 - 2))
             
             'no, from 16_22 this is legal:
             ''If Len(WVName) = 0 Then e_app "Empty variable name inside the string: """ & Mid(SourceStr, pos, 20) & """  "
             
             'find var value and add it:
             res = res & var_Get(WVName)
             'pos2 - \ pos2+1 - $; pos2+2 - var
             pos = pos2 + 3 + Len(WVName)
        Case alph__EscInText:     '\\
        
             'this is a good idea to put \moo ---> mooo
             res = res & alph__EscInText: pos = pos2 + 2
             'put all new shortcuts below:
             'case ...       : Res = Res & .... ' new shotcut
             '                 pos = pos2 + 2
        
        Case "T"
             'get value from file
             'full "analogy with" "variable" case:
             'skip "\T" in \T\$variable,pos,len :
             
             EscaperPosition2 = EscaperPosition2 + 2
             WVarLimitor = InStr(EscaperPosition2, _
                           SourceStr, alph__VariableEscapeLimitor)
             If WVarLimitor = 0 Then
                'var name is limited by the end of string;
                'very good for string fragments
                'extracted from parent string:
                WVarLimitor = SourceLen + 1
             End If
             WVName = Trim(Mid(SourceStr, EscaperPosition2, _
                      WVarLimitor - EscaperPosition2))
             
             res = res & moDv.GetVar(WVName)
             pos = EscaperPosition2 + 1 + Len(WVName)
        
        Case "c"
             res = res & ","
             pos = pos2 + 2
        Case "s"
             res = res & " "
             pos = pos2 + 2
        Case "p"
             res = res & "."
             pos = pos2 + 2
        
        Case "P", "I" '-find position and inverse position
              'pos2 - is escaper's position:
              WSS = Mid(SourceStr, pos2 + 2)
              wComma = InStr(WSS, ",")
              If 2 > wComma Then e_raise _
                 "No comma after \P shortcut " & _
                 "or parameter to search is empty: " & ve & _
                 Left(WSS, 100)
              'wSecondComma = InStr(wComma + 1, WSS, ",")
              ws = Left(WSS, wComma - 1)
              wPar = var_SubstituteShortCuts(ws)
              wSecondPar = var_SubstituteShortCuts(Mid(WSS, wComma + 1))
              'search wpar in wSecondPar:
              Select Case WSecondChar
                   Case "P":  res = res & InStr(wSecondPar, wPar)
                   Case "I":  res = res & InStrRev(wSecondPar, wPar)
              End Select
              Exit Do
              
              
        Case "S": 'output length of the rest:
             'pos2 is  a position of EscapeCharacter
             '"S" is the next character after EscapeCharacter
             res = res & _
                   Len(var_SubstituteShortCuts( _
                       Mid(SourceStr, pos2 + 2)))
             Exit Do
              
        Case "D":
             'this is ugly, forgive me CPU ...
             res = res & Replace(Replace(Replace(Replace( _
                         Replace(var_SubstituteShortCuts( _
                       Mid(SourceStr, EscaperPosition2)), _
                               "\", "\\"), _
                             Chr(0), "\z"), _
                              vbCrLf, "\l"), _
                                 vbCr, "\r"), _
                                  vbLf, "\n")
             Exit Do
              
             'Convert to Hexadecimal format:
        Case "x": res = res & _
                        String2Hex(var_SubstituteShortCuts( _
                        Mid(SourceStr, EscaperPosition2)))

             Exit Do
              
        Case "X": res = res & _
                        Hex2String(var_SubstituteShortCuts( _
                        Mid(SourceStr, EscaperPosition2)))

             Exit Do
        
        
        Case "d":
             res = res & ReDe(var_SubstituteShortCuts( _
                       Mid(SourceStr, EscaperPosition2)), "\")
             Exit Do
              
        '=============================================
        ' TRIMMING
        ' Trimming is notable by two featrues:
        '     1. nothing is added to res
        '     2. SourceStr may be truncated from bottom
        '        in cases w,W,g,G
        '----------------------------------------------
        Case "f", "F", "w", "W", "g", "G"
             WUnescapedString = var_SubstituteShortCuts( _
                Mid(SourceStr, EscaperPosition2))
             SourceLen = Len(WUnescapedString)
             If 0 = SourceLen Then Exit Do
             
             'advance pos for case of GroundTrimming:
             pos = 1
             If UCase(WSecondChar) = "G" Then GoTo GroundTrimming
 
             For wi = 1 To SourceLen
                 ws = Mid(WUnescapedString, wi, 1)
                 Select Case ws
                    Case " ", vbTab
                    Case vbCr, vbLf
                         If "f" = WSecondChar Or _
                            "w" = WSecondChar Then _
                            GoTo SolidFound
                    Case Else
                         GoTo SolidFound
                 End Select
             Next

SolidFound:
             pos = wi
             If "f" = WSecondChar Or _
                "F" = WSecondChar Then
                res = res & Mid(WUnescapedString, wi)
                GoTo EndFunction
             End If
             If pos > SourceLen Then GoTo ContinueLoop
             'end of face-soft-trimming

GroundTrimming:
             For wi = SourceLen To pos Step -1
                 ws = Mid(WUnescapedString, wi, 1)
                 Select Case ws
                    Case " ", vbTab
                    Case vbCr, vbLf
                         If "g" = WSecondChar Or _
                            "w" = WSecondChar Then _
                            GoTo GroundDone
                    Case Else
                         GoTo GroundDone
                 End Select
             Next
GroundDone:  If wi < pos Then
                'nothing left from the string
                GoTo EndFunction
             End If
             'VITAL STEP: only here at current development:
             'changing copy of source string:
             res = res & Mid(WUnescapedString, pos, wi - pos + 1)
             GoTo EndFunction
             '----------------------------------------------
             '  ef TRIMMING
             '==============================================
              
        
             '==============================================
             '  REPLACEMENT
             '----------------------------------------------
        Case "R"
             Limitor = InStr(EscaperPosition, SourceStr, ",")
             If 0 = Limitor Then
                'wrong \R syntax
                'kk.later.D: don't put exception message
                '          to this output string:
                '          make normal message:
                res = res & "Incorrect operator \R syntax: " _
                      & vbCrLf & Mid(SourceStr, EscaperPosition)
                'no string after control:
                'res is done:
                GoTo EndFunction
             End If
             
             wPar = Mid(SourceStr, EscaperPosition2, _
                    Limitor - EscaperPosition2)
             wPreSubString = Mid(SourceStr, Limitor + 1)
             
             wComma = InStr(wPar, ".")
             If 0 = wComma Then
                'kk.later see 'kk.later.D
                res = res & "Incorrect operator \R syntax: " _
                      & vbCrLf & Mid(SourceStr, EscaperPosition)
                GoTo EndFunction
             End If
             ws = Left(wPar, wComma - 1)
             
             'this kind of "ifs" is not required, but
             'may shotcut time for stack operations:
             If InStr(ws, alph__EscInText) > 0 Then
                WSS = var_SubstituteShortCuts(ws)
             Else
                WSS = ws
             End If
             
             If "" = WSS Then
                'kk.later see 'kk.later.D
                res = res & "Incorrect operator \R syntax: " _
                      & ve & "Empty searchee:" & ve & _
                      Mid(SourceStr, EscaperPosition)
                GoTo EndFunction
             End If
             
             ws2 = Mid(wPar, wComma + 1)
             If InStr(ws2, alph__EscInText) > 0 Then
                wss2 = var_SubstituteShortCuts(ws2)
             Else
                wss2 = ws2
             End If
           
             res = res & Replace( _
                var_SubstituteShortCuts(wPreSubString), _
                WSS, wss2)
             GoTo EndFunction
             '----------------------------------------------
             '  ef REPLACEMENT
             '==============================================
              
              
   '==============================================
   '  CONDITIONAL INSERTION
   '----------------------------------------------
   Case "?"
       wp1 = InStr(EscaperPosition2, SourceStr, ",")
       If 0 = wp1 Then e_raise c_Cond & "first comma " & ve & _
                       Mid(SourceStr, EscaperPosition, 200)
       wp2 = InStr(wp1 + 1, SourceStr, ",")
       If 0 = wp2 Then e_raise c_Cond & "second comma " & ve & _
                       Mid(SourceStr, wp1, 200)
       wp3 = InStr(wp2 + 1, SourceStr, ",")
       If 0 = wp3 Then e_raise c_Cond & "third comma " & ve & _
                       Mid(SourceStr, wp2, 200)
       wp4 = InStr(wp3 + 1, SourceStr, ",")
       If 0 = wp4 Then wp4 = SourceLen + 1
             
       ws1 = Mid(SourceStr, EscaperPosition2, _
                 wp1 - EscaperPosition2)
       ws2 = Mid(SourceStr, wp1 + 1, wp2 - wp1 - 1)
       ws3 = Mid(SourceStr, wp2 + 1, wp3 - wp2 - 1)
       ws4 = Mid(SourceStr, wp3 + 1, wp4 - wp3 - 1)
       ws1 = var_SubstituteShortCuts(ws1)
       ws2 = var_SubstituteShortCuts(ws2)
       If ws1 = ws2 Then
          res = res & var_SubstituteShortCuts(ws3)
       Else
          res = res & var_SubstituteShortCuts(ws4)
       End If
       res = res & var_SubstituteShortCuts( _
                   Mid(SourceStr, wp4 + 1))
       GoTo EndFunction
 '----------------------------------------------
 '  ef CONDITIONAL INSERTION
 '==============================================
              
              
        '=================================================
        '  DOUBLE SUBSTITUTION
        '-------------------------------------------------
        Case "#"
             wp1 = InStr(EscaperPosition2, SourceStr, ",")
             If 0 = wp1 Then wp1 = SourceLen + 1
            
             ws1 = Mid(SourceStr, EscaperPosition2, _
                      wp1 - EscaperPosition2)
             ws1 = var_SubstituteShortCuts(ws1)
             ws1 = var_SubstituteShortCuts(ws1)
             
             res = res & ws1 & var_SubstituteShortCuts( _
                         Mid(SourceStr, wp1 + 1))
             GoTo EndFunction
        '-------------------------------------------------
        '  ef DOUBLE SUBSTITUTION
        '=================================================
              
              
        Case "B", "E", "M", "V" 'handle shortcuts:
                           'left(s,xxx), right, middle:
             ws = Mid(SourceStr, pos2 + 2)
             'call recursively:
             'ws = var_SubstituteShortCuts(WSS)

             Limitor = InStr(ws, ",")
             If 0 = Limitor Then
                'no string after control:
                'res is done:
                Exit Do
             End If
             wPar = Left(ws, Limitor - 1)
             wPreSubString = var_SubstituteShortCuts( _
                             Mid(ws, Limitor + 1))
             'update 21_76: now, period, not a comma:
             wComma = InStr(wPar, ".")
             espot = "parsing substrings parameters: " & wPar
             If 0 <> wComma Then
                wFirstPar = var_SubstituteShortCuts(Left(wPar, wComma - 1))
                wSecondPar = var_SubstituteShortCuts(Mid(wPar, wComma + 1))
             Else
                wFirstPar = var_SubstituteShortCuts(wPar)
             End If
      
             Select Case WSecondChar
                 Case "B":  res = res & Left(wPreSubString, CLng(wFirstPar))
                 Case "E":  res = res & Right(wPreSubString, CLng(wFirstPar))
                 Case "M", "V"
                      If 0 <> wComma Then
                         If "M" = WSecondChar Then
                             res = res & Mid(wPreSubString, CLng(wFirstPar), CLng(wSecondPar))
                         Else
                             res = res & TakeValueByKey(wPreSubString, wFirstPar, wSecondPar, True)
                         End If
                      Else
                         If "M" = WSecondChar Then
                             res = res & Mid(wPreSubString, CLng(wFirstPar))
                         Else
                             '\V6,table   Default separator is " ". Value always trimmed.
                             res = res & TakeValueByKey(wPreSubString, wFirstPar, " ", True)
                         End If
                      End If
             End Select
             Exit Do
        Case "L", "U"
             ws = Mid(SourceStr, pos2 + 2)
             'call recursively:
             wPreSubString = var_SubstituteShortCuts(ws)

             Select Case WSecondChar
                 Case "L":  res = res & LCase(wPreSubString)
                 Case "U":  res = res & UCase(wPreSubString)
             End Select
             Exit Do
        Case "H" 'flip horizontally
             ws = Mid(SourceStr, pos2 + 2)
             'call recursively:
             wPreSubString = var_SubstituteShortCuts(ws)
             res = res & StrReverse(wPreSubString)
             Exit Do

        Case "e" '\e - extend string
             ws = Mid(SourceStr, EscaperPosition2)
             Limitor = InStr(ws, ",")
             If 0 = Limitor Then Limitor = SourceLen + 1
             wPar = Left(ws, Limitor - 1)
             WUnescapedString = var_SubstituteShortCuts( _
                                Mid(ws, Limitor + 1))
             'update 21_76: now, period, not a comma:
             wComma = InStr(wPar, ".")
             espot = "parsing substrings parameters: " & wPar
             If 0 <> wComma Then
                wFirstPar = CLng( _
                  var_SubstituteShortCuts(Left(wPar, wComma - 1)))
                wPreSubString = _
                  var_SubstituteShortCuts(Mid(wPar, wComma + 1))
             Else
                wPreSubString = " "
                wFirstPar = CLng(var_SubstituteShortCuts(wPar))
             End If

             If 0 <> wFirstPar Then
                WUnescapedString = Replace( _
                            String(wFirstPar, "x"), "x", _
                                   wPreSubString) & _
                            WUnescapedString
             End If
             res = res & WUnescapedString
             Exit Do
        
        
        Case "h":
             'this is ugly, forgive me CPU ...
             res = res & Replace(Replace(Replace(Replace(var_SubstituteShortCuts( _
                       Mid(SourceStr, EscaperPosition2)), _
                            "&", "&amp;"), _
                             ">", "&gt;"), _
                              "<", "&lt;"), _
                              """", "&#34;")
             Exit Do

        Case "Z"
             res = res & Replace(var_SubstituteShortCuts( _
                       Mid(SourceStr, EscaperPosition2)), _
                           Chr(0), "\z")
             Exit Do

        Case Else:   'unknown shortcut: can be an exception message
                     'or including the shortcut as done before:
             e_raise "Unexpected character '" & WSecondChar & "' after escape character " & alph__EscInText
             
    End Select

ContinueLoop:
Loop

EndFunction:
var_SubstituteShortCuts = res

End Function


'adds ValueToAdd to open streams:
'
'NOTE reserved variables will not be streams
'
Public Sub var_AddToStreams(ValueToAdd$)
Dim wi&, VPosition&
  
If moDlg.StreamsOpen = 0 Then Exit Sub

'was this stream handled?:
For wi = 1 To moDlg.StreamsOpen
    VPosition = moDlg.Open_Streams(wi)
    If VPosition > 0 Then
    
      If VPosition > var_DEFAULT_NAMES_POSITION Then
         var_Values(VPosition) = var_Values(VPosition) & ValueToAdd
         var_AssignedDuringText(VPosition) = 1
      End If
      '    Select Case VPosition
      '      'Case 1: motz.eo_token = motz.eo_token & ValueToAdd
      '      'Case 2: motz.eo_type = motz.eo_type
      '      'Case 3: off_set = off_set & ValueToAdd
      '      'Case 4: seg_ment = seg_ment & ValueToAdd
      '      'Case 5: si_ze = si_ze & ValueToAdd
      '    End Select
    
    End If
Next
End Sub

Public Function var_Get$(VNameP$)
Dim VPosition&, VName$
Dim ws$, WSS$, n&, I&

VName = var_BuildVarName(VNameP)

If VName = "@" Then
   var_Get = moDlg.NestLevelVar(moDlg.dlgPs)
   Exit Function
End If

VPosition = var_GetIndexNotCreate(VName)

If 0 = VPosition Then
   var_Get = ""
   Exit Function
End If
  
If VPosition <= var_DEFAULT_NAMES_POSITION Then
   Select Case VPosition
        Case 1: var_Get = moTz.eo_token
        Case 2: var_Get = moTz.eo_type
        Case 3:
                moPc.MakeIndentReplacer
                var_Get = moDlg.Indent_Replacer
                moDlg.Indent_Replacer = ""
        Case 4: var_Get = S2SVersion
        'Case 5: var_Get = si_ze
        Case 6: var_Get = moTz.MSourceText
        Case 7: var_Get = moPr.MResultText
        Case 8: var_Get = CStr(moTz.muPsn)
        Case 9
             var_Get = p_basic
        Case 10
              var_Get = p_extension
        Case 11
              var_Get = p_rbasic
        Case 12
              var_Get = p_rextension
        Case 13: var_Get = moPc.local_ppath
        Case 14: var_Get = CStr(moDlg.dlgPs)
        Case 16: var_Get = moTz.StateNameStr(moDlg.RunTimeNest(moDlg.dlgPs))
        Case 17: var_Get = moPr.GetGlobalNest()
        
        Case 18: var_Get = Umbrella
        Case 19: var_Get = moFt.shield_RESULT_FILES
        Case 20: 'p_parent:
                 WSS = get_PathedParent( _
                       fAddLP_NoSlash(Umbrella, moPc.local_ppath), ws)
                 var_Get = ws
        Case 21: 'p_rparent
                 WSS = get_PathedParent( _
                       fAddLP_NoSlash(Umbrella & "\" & _
                              moFt.shield_RESULT_FILES, _
                              moPc.local_ppath), ws)
                 var_Get = ws
        Case 22: var_Get = moAc.gloProcessedLocalPaths
        Case 23: var_Get = p_file
        Case 24: var_Get = p_rfile
        Case 25: var_Get = p_file_for_GUI
        Case 26: var_Get = p_source
        Case 27: var_Get = CStr(moAc.Round)
        Case 28: var_Get = moPc.p_stop_browsing_project_tree
        Case 29, 30:
             If moDlg.mEsLIST_QUESTION_Start > 0 Then
                If 29 = VPosition Then
                   moDlg.mEsLIST_QUESTION_Len = InStr(moDlg.mEsLIST_QUESTION_Start, _
                                           var_Values(moDlg.glEsLIST_QUESTION_Ix), vbCrLf)
                Else
                   moDlg.mEsLIST_QUESTION_Len = InStr(moDlg.mEsLIST_QUESTION_Start, _
                                           var_Values(moDlg.glEsLIST_QUESTION_Ix), _
                                           vbCrLf & vbCrLf)
                End If
                If 0 = moDlg.mEsLIST_QUESTION_Len Then
                   moDlg.mEsLIST_QUESTION_Len = Len(var_Values(moDlg.glEsLIST_QUESTION_Ix)) + 1
                End If
                moDlg.mEsLIST_QUESTION_Len = moDlg.mEsLIST_QUESTION_Len - moDlg.mEsLIST_QUESTION_Start
                var_Get = Mid(var_Values(moDlg.glEsLIST_QUESTION_Ix), _
                          moDlg.mEsLIST_QUESTION_Start, moDlg.mEsLIST_QUESTION_Len)
             End If
        Case 31: 'created vars
                 n = UBound(var_Values)
                 ws = ""
                 For I = var_DEFAULT_NAMES_POSITION + 1 To n
                     ws = ws & Mid(var_List, I * 33 + 2, 32) & " = " & var_Values(I) & ve
                 Next
                 var_Get = ws
        Case 32: 'kk.do2 some var_Values(I) do not keep value.
                 'all vars
                 'Note: recursion to var_reserved_var_list is
                 'avoided by never assigning value to var_Values("var_reserved_var_list")
                 n = UBound(var_Values)
                 ws = ""
                 For I = 1 To n
                     ws = ws & Mid(var_List, I * 33 + 2, 32) & " = " & var_Values(I) & ve
                 Next
                 var_Get = ws
             
        Case 33: 'reserved
                 'kk.do2 some var_Values(I) do not keep value.
                 'Note: recursion to p_reserved_var_list is
                 'avoided by never assigning value to var_Values("var_reserved_var_list")
                 n = UBound(var_Values)
                 ws = ""
                 For I = 1 To var_DEFAULT_NAMES_POSITION
                     ws = ws & Mid(var_List, I * 33 + 2, 32) & " = " & var_Values(I) & ve
                 Next
                 var_Get = ws
        Case 34:
                 n = UBound(var_Values)
                 ws = ""
                 If var_BeforeRunTimeCreatedVarPosition >= var_DEFAULT_NAMES_POSITION Then
                    For I = var_BeforeRunTimeCreatedVarPosition + 1 To n
                        ws = ws & Mid(var_List, I * 33 + 2, 32) & " = " & var_Values(I) & ve
                    Next
                 End If
                 var_Get = ws

       Case 35:  var_Get = IIf(moTz.env_p_keywords_enabled, "T", "F")
       Case 36:  var_Get = IIf(moDlg.env_p_id_is_case_sensetive, "T", "F")
       Case 37:  var_Get = CStr(moAc.env_p_variables_when_bot)
       Case 38:  var_Get = IIf(moAc.env_p_clear_variables_at_eot, "T", "F")
       Case 39:  var_Get = IIf(moTz.env_p_recognize_vbtype_decl_chars, "T", "F")
       Case 40:  var_Get = moTz.env_p_vbtype
            
   End Select
Else
   var_Get = var_Values(VPosition)
End If
   
End Function

'USE used for debug, but seems perspective
'
Public Function var_GetNameByIndex$(Idx&)
var_GetNameByIndex = Mid(var_List, Idx * 33 + 2, 32)
End Function


'DESC   if var does not exist, it will be created
'
'INPU   VNameP - raw name - will be analysed
'
'
Public Function var_GetIndex&(VNameP$)
Dim VName$

VName = var_BuildVarName(VNameP)

If VName = "@" Then
   e_raise "Variable name starting with ""@"" " & ve & _
           "do not have an index."
End If
  
var_GetIndex = var_GetIndexMayCreate(VName)

End Function


'=============================================
'
' assigns VValue to the variable VName
' if VName does not exist then it is initiated
'
'=============================================
Public Sub var_Set(VNameP$, VValue$)
Dim VPosition&, VName$

VName = var_BuildVarName(VNameP)

If "@" = VNameP Then
   moDlg.NestLevelVar(moDlg.dlgPs) = VValue
   Exit Sub
End If

VPosition = var_GetIndexMayCreate(VName)
var_SetByKnownIndex VPosition, VValue

  
End Sub
Public Function varValues$(n&)
varValues = var_Values(n)
End Function


Private Sub Class_Initialize()
var_Init
End Sub


