VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFolderTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public p_source$        'target: file or folder
Public shield_RESULT_FILES$     '="RESULT_FILES" never changed during recursions
Public p_rfile$         'resut-single-unit-name
Public p_extension$     'to use in .bot event
Public p_file$                  '?File, not a path.
Public p_rextension$
Public p_rbasic$
Public p_basic$
Public p_file_for_GUI$  'to be displayed for user on GUI

Public local_ppath$
Public profold_Deepness&

Public abs_umbrella_for_include$
Public abs_umbrella_for_save$

Public abs_rfile$               'Must be in Actos?

Public Umbrella_plus_shield$    'Must be in Actos?
Public Umbrella$                'Must be in Actos?
                                '-Full Path to common parent
                                ' in tree:
                                ' Umbrella\Source\Source_SubTree
                                ' Umbrella\RESULT_FILES\Source\Source_SubTree

Private moTz As CTokenizer
Private moPc As CProcedure
Private moDlg As CDialog
Private moAc As Acto

'DESC  One-tieme called sub at project startup.
'
'INPUT EntryToProcess
'
'OUTP  Umbrella
'      Source_OwnName
'
Public Sub PrepareProjectTreeNames(EntryToProcess$)

  local_ppath = ""  'for clarity

  Dim s$ 'This fixes "non-returning" a value by reference:
         'Unknown behavior:
  Umbrella = get_PathedParent(EntryToProcess, s)
  p_source = s

  If "" = EntryToProcess Then
     Umbrella_plus_shield = ""
     abs_umbrella_for_save = ""
     abs_umbrella_for_include = ""
     abs_rfile = ""
     Exit Sub
  End If
   
  Umbrella_plus_shield = Umbrella & "\" & shield_RESULT_FILES
  'prepare it before enter folders
  abs_umbrella_for_save = Umbrella_plus_shield
  abs_umbrella_for_include = Umbrella
  abs_rfile = Umbrella_plus_shield & "\" & p_source

End Sub


Public Sub ProcessFolder(file_name$)

Dim F$, I&, ws$, WSS$
Dim CommonUmbrella$, CommonResult$
Dim FolderStack$(), FileStack$()
Dim local_path_stashed$
Dim xMe$, xNo&

On Error GoTo he

If moAc.flag_PROJECTS_STOPPED Then Exit Sub
If "T" = moPc.p_stop_browsing_project_tree Then Exit Sub
If moTz.flagPermitBeginningOf Then moDlg.proc_SlideEvent_Modify file_name, "bof"

 profold_Deepness = profold_Deepness + 1
local_path_stashed = local_ppath
If "" <> local_ppath Then local_ppath = local_ppath & "\"
 local_ppath = local_ppath & file_name

'generalizations: July 1, 2003:
GoSub FixFileSystemVariables
'ef generalizations

'KK.bug fix:  July 1, 2003:
moAc.proc_DialogWithoutFile
If moDlg.flag_TEXT_STOPPED Then Exit Sub
'end of fix

'On Error GoTo he

ReDim FolderStack(0)
ReDim FileStack(0)

CommonUmbrella = Umbrella & "\" & local_ppath
CommonResult = Umbrella & "\" & shield_RESULT_FILES    'may need, but only "once";
 abs_umbrella_for_save = CommonResult


'RESTORING targets to put results there: ============================================================================================
If "Y" <> moAc.SaveResultsToDisk Or (Not moAc.env_save_file_mode) _
   Then GoTo ResultFolderCreationSkipped
ws = CommonResult & "\" & local_ppath
If Dir(ws, vbDirectory) = "" Then
   'folder does not exist, create it:
   MkDir ws
ElseIf Not ((GetAttr(ws) And vbDirectory) = vbDirectory) Then
   'the target is a file
   fDeleteSilently ws
   If Dir(ws, vbDirectory) = "" Then
         'create folder after cleaning up the space:
         MkDir ws
   Else
         'no, file still exists:
         ws = "File " & ws & " must be a folder." & ve & _
              "Cannot delete it." & ve & _
              "Perhaps former source project tree " & ve & _
              "is read-only and is non-compatible with the new."
         e_stop ws
   End If
End If
'ef RESTORING =======================================================================================================================


ResultFolderCreationSkipped:
'=========== MAKE FILES' AND FOLDERS' STACKS  ==================================================
'find first file:
F = Dir(CommonUmbrella & "\*.*", vbDirectory)
Do While F <> ""
   DoEvents
   If (GetAttr(CommonUmbrella & "\" & F) And vbDirectory) = vbDirectory Then
      If F <> "." And F <> ".." Then AddNewString FolderStack, F
   Else
      AddNewString FileStack, F
   End If
   F = Dir
Loop
'=========== ef MAKE FILES' AND FOLDERS' STACKS  ================================================


'=========== RPOCESSION FILES PART OF THIS DIRECTORY ===========================
For I = 1 To UBound(FileStack)
    DoEvents
     p_file = FileStack(I)
    moAc.Proc_Dialog_with_Text
    If moAc.flag_PROJECTS_STOPPED Then GoTo ExitSub
    If "T" = moPc.p_stop_browsing_project_tree Then GoTo ExitSub
Next
'=========== ef RPOCESSION FILES PART OF THIS DIRECTORY =========================
     

'========= RECURSION INTO FOLDERS: ===========================================================
For I = 1 To UBound(FolderStack)
       DoEvents
       ' local_ppath will be immediately updated there:
       ' local_ppath =  local_ppath & "\" & FolderStack(I)
       ProcessFolder FolderStack(I)
       'restore:
       ' local_ppath = local_path_stashed
       'psee note at ExitSub
       If moAc.flag_PROJECTS_STOPPED Then GoTo ExitSub   'to make stop "smoother"
       If "T" = moPc.p_stop_browsing_project_tree Then GoTo ExitSub
Next
'========= ef RECURSION INTO FOLDERS =========================================================
   
   
ExitSub:   local_ppath = local_path_stashed
           profold_Deepness = profold_Deepness - 1
          GoSub FixFileSystemVariables 'KK.fix: July 2, 2003
          If moTz.flagPermitBeginningOf Then _
             moDlg.proc_SlideEvent_Modify file_name, "eof"
          'KK.bug fix:  July 1, 2003:
          moAc.proc_DialogWithoutFile
          'end of fix
          
          'no need to restore global value:
          ' abs_umbrella_for_save = CommonResult
          'because it will be reset when exiting top ProcessFolder
Exit Sub


FixFileSystemVariables:

'generalizations: July 1, 2003:
 abs_umbrella_for_include = fAddLP_NoSlash(Umbrella, local_ppath)
 abs_umbrella_for_save = fAddLP_NoSlash( _
                         Umbrella_plus_shield, local_ppath)
 p_file = file_name
 p_extension = GetFileExtention(p_file, p_basic)
 p_file_for_GUI = p_file
 p_rbasic = p_basic
 p_rextension = p_extension
 p_rfile = p_file
'ef generalizations
Return


he:  profold_Deepness = profold_Deepness - 1
     xMe = Err.Description
     xNo = Err.Number
     Resume xNext
xNext:
     On Error GoTo 0
     Err.Raise xNo, , xMe & " in ProcessFolder"


End Sub

Public Sub SetMoActo(ac As Acto)
Set moAc = ac
End Sub

Public Sub SetMoDialog(dlg As CDialog)
Set moDlg = dlg
End Sub

Public Sub SetMoTokenizer(tz As CTokenizer)
Set moTz = tz
End Sub

Public Sub SetMoProcedure(pc As CProcedure)
Set moPc = pc
End Sub


