Attribute VB_Name = "Utilities"
Option Explicit

'Apparently converts string's characters to string of their
'its hexadecimal representation.
'
Public Function Hex2String$(s$)

Dim SL
Dim Even As Boolean  'Even means first char in hex. pair.
Dim iASC&            'Char's ASCII code.

Dim Accomulated&
Dim I&, wi&

'Assembly result in array for speed.
Dim ResultA() As Long
Dim rIx&   'Index of ResultA

SL = Len(s)
If 0 = SL Then Exit Function
ReDim ResultA(SL)    'Reserve space for speed.

Even = True
For I = 1 To SL
    iASC = Asc(Mid(s, I, 1))
    Select Case iASC
           Case 48 To 57:  wi = iASC - 48 'Parse digits.
           Case 65 To 70:  wi = iASC - 55 'Disregard upper case.
           Case 97 To 102: wi = iASC - 87 'Disregard low case.
           Case Else: wi = -1  'Skip all irrelevant chars.
                               'Use wi as a flag.
    End Select
    
    If wi > -1 Then
       If Even Then
          Accomulated = wi * 16  'Accomulate high digit.
          Even = False
       Else
          rIx = rIx + 1   'Count resulting chars.
          ResultA(rIx) = Accomulated + wi
          Accomulated = 0
          Even = True
       End If
    End If
Next

Dim R$
R = Space(rIx)  'Try to make move fast.
For I = 1 To rIx
    Mid(R, I, 1) = Chr(ResultA(I))  'Try to make move fast.
Next

Erase ResultA
Hex2String = R

End Function


'DESC   Apparently converts hexadecimal string to normal string.
'YIELS  Yes
'XCEP   Free
'
Public Function String2Hex(s$)

Dim I&, n&, n1&, n2&, TLen&, res$

TLen = Len(s)
If TLen < 1 Then Exit Function

For I = 1 To TLen
    DoEvents
    n = Asc(Mid(s, I, 1))
    n1 = n \ 16 + 48
    n2 = (n Mod 16) + 48
    If n1 > 57 Then n1 = n1 + 7
    If n2 > 57 Then n2 = n2 + 7
    res = res & Chr(n1) & Chr(n2)
Next
String2Hex = res

End Function
'"lossy but avoids duplication of \":
's = Replace(s, "\", "\\")
'
Public Function LossySlash$(s$)
    
    Dim ws$
    ws = Replace(s, vr, "\r")
    ws = Replace(ws, vl, "\n")
    LossySlash = Replace(ws, Chr(0), "\z")

End Function


'DESC replaces \r,\n,chr(0) with ^r, ^n, ^z
'
Public Function LossyHat$(s$)

  Dim ws$
    
  ws = s
    
  's = Replace(s, "^", "^^")
  ws = Replace(s, vr, "^r")
  ws = Replace(ws, vl, "^n")
  LossyHat = Replace(ws, Chr(0), "^z")
  
End Function


Public Function LossyZero$(s$)
    LossyZero = Replace(s, Chr(0), "\z")
End Function

'EXCE free
'DESC converts "",T, Y, 1 into True;
'     otherwise returns False;
'
Public Function Make_Boolean(Str$) As Boolean
 Select Case UCase(Left(Str, 1))
        Case "", "T", "Y", "1": Make_Boolean = True
        Case Else: Make_Boolean = False
    End Select
End Function

'INPUT: Separator can be empty. Usually "=" or " ".
'       Text - Key/Separator/Value blocks separated by CRLF or CR or LF.
'              Spaces in Key counted.
'              Second and consequent Keys must precede by LF.
'
'USAGE  Typical usage is filtering by table of codes.
'
Public Function TakeValueByKey$(Text$, Key$, Separator$, DoTrimValue As Boolean)

Dim SearchToken$, TokenLen&
Dim FoundPosition&, EndPosition&, result$

If Len(Key) = 0 Then Exit Function

SearchToken = Key & Separator
TokenLen = Len(SearchToken)

If Left(Text, Len(SearchToken)) = SearchToken Then
   FoundPosition = 1
Else
   SearchToken = vbLf & Key & Separator
   TokenLen = Len(SearchToken)
   FoundPosition = InStr(Text, SearchToken)
   If 0 = FoundPosition Then Exit Function
End If
FoundPosition = FoundPosition + TokenLen

'Position is found for sure. Get Value.
EndPosition = InStr(FoundPosition, Text, vbCr)
If 0 = EndPosition Then EndPosition = Len(Text) + 1

result = Mid(Text, FoundPosition, EndPosition - FoundPosition)
EndPosition = InStr(result, vbLf)

If DoTrimValue Then
   If EndPosition > 0 Then
      TakeValueByKey = Trim(Mid(result, FoundPosition, EndPosition - FoundPosition))
   Else
      TakeValueByKey = Trim(result)
   End If
Else
   If EndPosition > 0 Then
      TakeValueByKey = Mid(result, FoundPosition, EndPosition - FoundPosition)
   Else
      TakeValueByKey = result
   End If
End If
      

End Function

'INPUT: TestString
'OUTPUT: if the first char is digit, => returns true.
'        if empty or not digit, => false
Public Function FirstIsDigit(TestString$) As Boolean
Dim WDig
FirstIsDigit = False
If TestString = "" Then Exit Function
WDig = Asc(Left(TestString, 1))
If WDig < 58 And WDig > 47 Then
   FirstIsDigit = True
   Exit Function
End If
End Function




'//////////////////////////////////////////////////////////
'  UTILITIES
'==========================================================
'  Checks that all characters in strings are digits.
'----------------------------------------------------------
' if empty, returns false
' if all are digits, returns true
' if not, returns false
Public Function AllDigits(s)
Dim I, L, j

AllDigits = False
L = Len(s)
If L = 0 Then Exit Function

For I = 1 To L
    j = Asc(Mid(s, I, 1))
    If j >= 58 Or j < 48 Then Exit Function
Next
AllDigits = True
End Function
'//////////////////////////////////////////////////////////




'DESC Increases array-of-strings size exactly by 1.
'
'do2 Must be better optimized.
'
Sub AddNewString(StringsArray$(), NewString$)
    Dim I&
    I = UBound(StringsArray)
    ReDim Preserve StringsArray(I + 1)
    StringsArray(I + 1) = NewString
End Sub

'USE only in parse schema
'
Function take_asc$(s$)
Dim I%

Dim xNum&, xDesc$
On Error GoTo he

If IsNumeric(s) Then
   I = CInt(s)
   If I >= 0 And I < 256 Then
      take_asc = Chr(I)
   End If
Else
  e_raise "Not numeric ascii value = `" & s & "`"
End If

Exit Function

he: xNum = Err.Number
    xDesc = Err.Description
    Resume xNext
    
xNext:   Err.Raise xNum, , "Cannot convert to character." & vbCrLf & xDesc

End Function

